function x_estimate = GL_synthesis(X_target,L,S,max_it)
% Given a Modified Short Time Fourier Transform Magnitude |Yw|, the algorithm tries to
% estimate a real signal for which the STFT is as close as possible (MSE) to Yw.
%
% Created by Alan Tygel
% Date: 13/05/2009

close all;

M = size(X_target,2); %number of frames

w = hamming2(L,S);
w = w(:);
T = L+(M-1)*S;

%%%%%%% Initialize x_estimate %%%%%%%%%%%
x_estimate = 1e-10*randn(T,1);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

figure;
title('x_estimate')
i = 1;
while (i < max_it)

	%%%%%%% M-Constrained Transform %%%%%%%%%
	X_estimate = STFT(x_estimate,L,S,M);
  if (mod(i,2) == 0)
		subplot(2,1,1)
		imagesc(abs(X_estimate))
		pause(0.01);
  end
    
  X_Mestimate = X_estimate .* abs(X_target)./(abs(X_estimate)+1e-10);
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	%%%%%%% inverse transform %%%%%%%%%%%%%%%
	for n = 1:T
		auxA = 0;
		auxB = 0;
		for m = ceil((n-L)/S):floor((n-1)/S)
			if((m<=M-1)&&(m>-1))
					auxx = real(ifft(X_Mestimate(:,m+1)));
					auxA = auxA + (w(n-m*S))*auxx(n-m*S);
					auxB = auxB + w(n-m*S)^2;
			end
		end %for m
%             if(i>5)
%              fprintf('n = %d\t\n',n);
%              fprintf('m = %d\t\t',ceil((n-L)/S):floor((n-1)/S));
%              fprintf('\n');
%              mm = ceil((n-L)/S):floor((n-1)/S);
%              fprintf('n-m*S = %d\t',n-mm*S);
%              fprintf('\n\n');
%              %pause;
%             end
		x_estimate(n) = auxA/(auxB+1e-10);
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  end %for n
	i = i+1;
	if (mod(i,2) == 0)
		subplot(2,1,2)
		plot(x_estimate)
		pause(.01);
	end
end %while


%  figure
%  x2 = iSTFT(X_Mestimate,L,S,M,T);
%  plot(x2)
%  title(iSTFT)

% wavwrite(x_estimate/max(abs(x_estimate)),FS,16,'out.wav');

end
