function [PEAQ match_matrix]= SF_PEAQ_eval(sources, separated,Fs,Nb,outname)
% [PEAQ match_matrix]= SF_PEAQ_eval(sources, separated,Fs,Nb,outname)
%
% Calculates the ODG between sources and separated signals.
% Based on toolbox by P. Kabal, available at http://www-mmsp.ece.mcgill.ca/Documents/Downloads/PQevalAudio/
%
% INPUT
% sources: a cell containing all original sources in the 'signal' field. 
% separated: a cell containing all separated signals in the 'signal' field.
% Fs: Sample Rate
% Nb: number of bits of the signal representation
% outname: name of the output file
% Author: Alan F. Tygel
% Last Modified: 19/11/2009


cd ../PQevalAudio

D = length(sources);

match_matrix = zeros(D,2);

for d = 1:D

end

ODG = zeros(D,1);

for d = 1:D
    sources{d}.signal = resample(sources{d}.signal,48000,Fs);
    separated{d}.signal = resample(separated{d}.signal,48000,Fs);
end

gain_b = zeros(D);

id = int2str(round(1e6*sum(clock)));

for ref=1:D    
    for tes=1:D

        wavwrite(sources{ref}.signal,48000,Nb,['sou',id,'.wav']);    
        wavwrite(separated{tes}.signal,48000,Nb,['tes',id,'.wav']);

        
        cd '../QAforEcho/bin';

        [a b] = system(['./CompAudio ../../PQevalAudio/sou',id,'.wav ../../PQevalAudio/tes',id,'.wav']);
        ind = strfind(b,'Gain for File B = ');
        
        gain_b(ref,tes) = str2double(b(ind+18:ind+22))

				cd ../../PQevalAudio

				if(gain_b(ref,tes) > .1)
					wavwrite(gain_b(ref,tes) * separated{tes}.signal,48000,Nb,['tes',id,'.wav']);					
					ODG(tes) = PQevalAudio(['sou',id,'.wav'],['tes',id,'.wav']);
				else
					ODG(tes) =-5;
				end
        %pause;
    end
		[maxODG(ref) ind] = max(ODG);
		fprintf('PEAQ ,%s, %d , %d , %1.3f\n' ,outname,ref,ind,maxODG(ref));
		match_matrix(ref,:) = [ref ind];  
end


system(['rm sou',id,'.wav tes',id,'.wav']);

PEAQ = maxODG;
cd ../mfiles/


end