function [x y delay] = SF_aligner(x,y,Fs,nb)

%[x1 y1 delay1] = SF_aligner(x,y,Fs,nb)
%
% Aligns signals x and y based on correlation. The delayed singal will
% remain untouched, while the advanced signal will be modified.
%
% INPUT
% x: original
% y: to be aligned
% Fs: Sample Rate
% nb: number of bits of the signal representation
%
% OUTPUT
% x1: first aligned signal
% x2: second aligned signal
% delay: applied delay
%
% Author: Alan F. Tygel
% Last Modified: 01/02/2009

wavwrite(.1*x,Fs,nb,'../align/x_tmp.wav');
wavwrite(.1*y,Fs,nb,'../align/y_tmp.wav');

f = fopen('../align/out.m','w');
fclose(f);

%!../align/CompAudio -d -1000:1000 ../align/x_tmp.wav ../align/y_tmp.wav | grep delay >> ../align/out.m



delay = 0;
addpath('../align')
out;

%  f = fopen('../align/out.m','a');
%  fprintf(f,';');
%  fclose(f);
delay = -296;
	if(delay>0)
		y = [y(delay+1:end) zeros(1,delay)];
    else
        y = [zeros(1,-delay) y(1:end+delay)];
    end

    N = min(length(x),length(y));
    x = x(1:N);
    y = y(1:N);
    
end


