function SF_disp_plot_f(W,H,Lambda)

% SF_disp_plot_f(W,H,Lambda)
%
% Plots matrices W,H, and resulting spectrogram
%
% INPUT
% W: W matrix containing spectral description
% H: H matrix, containing temporal description
% Lambda: Recontructed spectrogram
%
%
% Author: Alan F. Tygel
% Last Modified: 28/01/2009

I = size(W,1);
J = size(H,2);
TAU = size(W,3);
PHI = size(H,3);
D = size(H,1);



  WW = [];
  HH = [];

  for d= 1:D
    W1 = zeros(I,TAU);
    W1(:,:) = W(:,d,:);
    WW = [WW W1/(max(max(W1))+eps) ones(I,1)];
	
    H1 = zeros(J,PHI);
    H1(:,:) = H(d,:,:);
    HH = [HH ; H1'/(max(max(H1))+eps) ; ones(1,J);];
  end	

  subplot(3,4,[2 4])
  imagesc(1-HH);colormap(gray);axis xy;
  ylabel('\phi'); 
  subplot(3,4,[5 9])
  imagesc(1-WW);colormap(gray);axis xy;
  ylabel('log-Frequency Bins'); xlabel('\tau')
  subplot(3,4,[6 8 10 12])
  imagesc(1-Lambda);colormap(gray);axis xy;
  xlabel('Time Frames')
  pause(0.01);

end