function SF_fast_cqt_synth(X,hopsize,Fs,Nb,name)

% SF_fast_cqt_synth(X,hopsize,Fs,Nb,name)
%
% Synthesizes a linear spectrogram resulted of a CQT analysis and writes resulting wav file.
% 
% INPUT
% X: complex linear Spectrogram
% FFT_T: fourier transform of the CQT matrix
% hopsize: hopsize
% Fs: sample rate
% Nb: number of bits
% name: name of the resulting audio file
%
%
% Author: Alan F. Tygel
% Last Modified: 9/02/2009


%resynthesis
%  subplot(1,3,1)
%  imagesc(abs(X))

XX = X + X(end:-1:1,:);

maxWSize = size(XX,1);
totalFrames = size(X,2);
x = zeros(hopsize*totalFrames+maxWSize,1);

%  janela = hamming(size(XX,1));
%  
%  for k=1:maxWSize/2
%  	gain_comp(k) = 1/(janela(k)^2+janela(k+round(maxWSize/2))^2);	
%  end


frames = 1; 
for kk = 1:hopsize:totalFrames*hopsize
    ifftx = real(ifft(XX(:,frames)));
		xx = ifftx;%.*janela;
    x(kk:kk+maxWSize-1) = x(kk:kk+maxWSize-1) + xx;
    %x(kk:kk+floor(maxWSize/2)-1) = x(kk:kk+floor(maxWSize/2)-1).*gain_comp';
    frames = frames+1;
end

size(x)
x = x(round(maxWSize/2):end-maxWSize);
size(x)
x = x./max(abs(x));

wavwrite(.9*x/max(abs(x)),Fs,Nb,name);

%fprintf('Terminou fast_cqt synth\n');

end