function [X PH] = SF_fft_analysis(x,L,FFT_size,S)
%[X PH] = SF_fft_analysis(x,L,FFT_size,S)
%
% Input:
%x: signal to be decomposed
%L: Window length (in samples)
%FFT_size:
%S: Window advance
%
% Output:
%X: STFT
%PH: phase
 
w = hamming2(L,S);

T = length(x);

M = floor((T-L)/S+1);

X = zeros(FFT_size,M);
X_aux = zeros(FFT_size,M);
PH = zeros(FFT_size,M);

x = x(:);
w = w(:);
 
 
for m = 0:M-1
    X_aux(:,m+1) = fft(x(1+m*S:m*S+L).*w,FFT_size);
		X(:,m+1) = X_aux(:,m+1);
		PH(:,m+1) = phase(X_aux(:,m+1));
end
 
 
 
end



%  function [X PH] = SF_fft_analysis(x,WS,FFT_size,S)
%  
%  % [X PH] = SF_fft_analysis(x,WS,FFT_size)
%  %
%  % Performs a short time fourier transform, resulting in a linear spectrogram
%  % 
%  % INPUT
%  % x: signal in time domais
%  % WS: Window Size
%  % FFT_size: Size o the FFT, which is the number of freq. bins
%  %
%  % OUTPUT
%  % X: Linear spectrogram (with phase)
%  % PH: phase of the spectrogram
%  %
%  %
%  % Author: Alan F. Tygel
%  % Last Modified: 09/02/2009
%  
%    total_frames = floor(length(x)/(WS/2));
%    X = zeros(FFT_size,total_frames);
%    janela = hamming(WS);
%    for frame = 1:total_frames-1
%        inicio = 1+(frame-1)*(WS/2);
%        x_janelado = x(inicio:inicio+WS-1).*janela;
%        X(:,frame) = fft(x_janelado,FFT_size);
%    end
%    PH = zeros(size(X));
%    for kk=1:size(X,2)
%        PH(:,kk) = phase(X(:,kk));
%    end
%  
%  end