%  function SF_fft_synth(X,Ws,out_pathname,Fs,Nb)
%  
%  % SF_fft_synth(X,Ws,out_pathname,Fs,Nb)
%  %
%  % Performs an ifft on a spectrogram, using a 50% hopsize with post-window and writes resulting wav-file.
%  % 
%  % INPUT
%  % X: Linear full spectrogram, expected to have phase
%  % Ws: Window Size
%  % FFT_size: Size o the FFT, which is the number of freq. bins
%  % out_pathname: name and path for the output signal
%  % Fs: Sample rate
%  % Nb: number of bits
%  %
%  % Author: Alan F. Tygel
%  % Last Modified: 09/02/2009
%  
%  
%  
%  
%  %ressintese
%  janela = hamming(Ws);
%  totalFrames = size(X,2);
%  x = zeros(totalFrames*(Ws/2)+Ws,1);
%  
%  for k=1:Ws/2
%  	gain_comp(k) = 1/(janela(k)^2+janela(k+Ws/2)^2);	
%  end
%  
%  
%  frames = 1;
%  for kk = 1:Ws/2:totalFrames*Ws/2
%      ifftx = real(ifft(X(:,frames)));
%      xx = ifftx(1:Ws).*janela;
%      x(kk:kk+Ws-1) = x(kk:kk+Ws-1)+ xx ;   
%      x(kk:kk+Ws/2-1) = x(kk:kk+Ws/2-1).*gain_comp';
%      frames = frames+1;
%  end
%  
%  x = x(1:end-Ws);
%  x = real(x);
%  
%  %wavwrite(.9*x/max(abs(x)),Fs,Nb,out_pathname);
%  wavwrite(x,Fs,Nb,out_pathname);
%  
%  end







function SF_fft_synth2(X,L,S,out_pathname,Fs,Nb)
%function x = iSTFT(X,L,S,M,T)
%X: spectrogram
%L: Window length (in samples)
%S: Window advance
%
%x: signal
 

w = hamming2(L,S);
w = w(:);
M = size(X,2); 
T = L+(M-1)*S;
x = zeros(T,1);
 
for m = 0:M-1
		aux = real((ifft(X(:,m+1))));
		plot(aux)
		pause;
    x(1+m*S:m*S+L) = x(1+m*S:m*S+L) + aux(1:L);
end

wavwrite(x,Fs,Nb,out_pathname);

end
