function A = SF_h_shift(A,s)
% A = SF_h_shift(A,s)
%
% Does the horizontal shift on a spectrogram matrix. The shift is not circular, zeros are
% placed to fill left-side or right-side of the matrix. 
%
% INPUT
% A: Matrix to be shifted
% s: number of frames to be shifted.
%
% OUTPUT
% B: shifted matrix
%
% Author: Alan F. Tygel
% Last Modified: 30/01/2009

	if(s~=0)
		A = circshift(A,[0 s]);
		if(s > 0)
		A(:,1:s) = 0;
		elseif(s<0)
		A(:,end+1+s:end) = 0;
		end
	end
end