%  function SF_onLine()

%1) read file
%2) break file in blocks (4s ?)
% do
%3.1) write next block in file
%3.2) rund soundfactmain
%3.3) write separated sources
%3.4) load factorization file (W,H)
% until last block


%Parameters

clear all;

D = 2;
TAU = 2;
PHI = 10;
WS = 512;
BLOCKSIZE = WS*200; %should be an even value times WS

filename = 'long_tpt';
analysis = 'fft';
obj_func = 'kld';
FFT_size = 1024;

max_it = 100;
out_name = 'out_';
delta = 10e-3;

R = 50;
results_SDR = zeros(R,D); % R x QAmethod x D
results_PEAQ= zeros(R,D); 
seeds = zeros(R,1); 

%  tic

not_conv = 0;

for rep = 1:R

	convergiu = 0;
	while(convergiu ~= 1)
	
		seed = 1e5*sum(clock);
		rand('state',seed);
		seeds(rep) = seed;


		[x Fs Nb] = wavread(['../audio_in/',filename,'/',filename,'_full.wav']);
		block_number = 0;
		
		
		x_final = [];
		
		
		for x_i = 1:BLOCKSIZE/2:length(x)
		
			block_number = block_number + 1;
		
			if(x_i+BLOCKSIZE > length(x))	
				final = length(x);
			else
				final = x_i+BLOCKSIZE-1;
			end
		
			wavwrite(x(x_i:final),Fs,Nb,['../audio_in/',filename,'/',filename,'.wav']);
		
			try
				if(strcmp(analysis,'fft'))
					algorithm = 'lnmf2d';
				else
					algorithm = 'nmf2d';
				end
				if (block_number == 1),algorithm = 'xxx';,end
				load(['../audio_in/',filename,'/',filename,'_',algorithm,'_',obj_func,'.mat']);
			catch
				W = 0;
			end
			
			SoundFact_main(filename,...
			'analysis',analysis,...
			'load_analysis','no',...
			'load_fact','no',...
			'obj_func',obj_func,...
			'processing','wiener',...
			'synthesis','ifft',...
			'd',D,'phi',PHI,'tau',TAU,'max_it',max_it,'delta',delta,...%	'out_name',['greensleaves_fft_kld_',int2str(block_number)],...
			'out_name',[out_name,num2str(block_number)],...
			'WS',WS,'FFT_size',FFT_size,...
			'disp_targ','off','disp_plot','off',...
			'bss_eval','no',...%);%,...
			'W_ini',W);
		
				x_out_aux = zeros(D,BLOCKSIZE);
		
				for d = 1:D
					aux = wavread(['../audio_out/',filename,'/',out_name,num2str(block_number),'_',num2str(d),'.wav']);
					if (length(aux) == BLOCKSIZE)
						x_out_aux(d,:) = aux; 
					else
						x_out_aux(d,:) = [aux' zeros(1,BLOCKSIZE-length(aux))]; 
					end
				end
			
				if (block_number ==1)
					x_final = zeros(D,BLOCKSIZE);
					for d = 1:D
						x_final(d,:) = x_out_aux(d,:); 
						x_final(d,1:BLOCKSIZE/2) = 2*x_final(d,1:BLOCKSIZE/2); 
					end
		
				else
					l = BLOCKSIZE;
					x_final = [x_final  zeros(D,ceil(l/2))]; 
		
					for d = 1:D
						x_final(d,end-l+1:end) = x_final(d,end-l+1:end) + x_out_aux(d,:); 
					end
				end
		
		end %loop blocos
		
		%removing zeros from the end
		if (BLOCKSIZE>length(aux))
			x_final =  x_final(:,1:end-(BLOCKSIZE-length(aux)));
		end
		
		for d = 1:D
			wavwrite(.1*x_final(d,:)/max(abs(x_final(d,:))), Fs,Nb,['../audio_out/',filename,'/',filename,'_final_',num2str(d),'.wav']);
		
%  			subplot(D,1,d)
%  			plot(.1*x_final(d,:)/max(abs(x_final(d,:))))
		end
		
		%QA
		sources = cell(D);
		[sources{1}.signal Fs Nb] = wavread(['../audio_in/',filename,'/',filename,'_s1.wav']);
		sources{2}.signal = wavread(['../audio_in/',filename,'/',filename,'_s2.wav']);
		
		separated = cell(D);
		separated{1}.signal = x_final(1,:);
		separated{2}.signal = x_final(2,:);
		
		warning('off')
		[PEAQ PEAQ_match]= SF_PEAQ_eval(sources, separated,Fs,Nb,filename);
		warning('on')
		[SDR SDR_match] = SF_BSS_eval(sources, separated,Fs,Nb,filename,0)
		
		
		results_SDR(rep,:) = SDR(:);
		results_PEAQ(rep,:) = PEAQ(:);
		
		if((norm(SDR_match-PEAQ_match) == 0) && (sum(SDR_match(:,2)) == sum(1:D)) && (sum(SDR < 0) == 0) && (sum(PEAQ == -5) == 0) ) 
			convergiu = 1;
		else
			disp(['#### nao convergiu ####']);
			not_conv = not_conv +1;
		end
	
	end %while
end %for

save results_SF_online results_SDR results_PEAQ not_conv seeds


%  toc


clear all;
%2348.55s