function y = SF_v_linear_shift(x,shift,b)

% y = SF_v_linear_shift(x,shift,b)
%
% Does the vertical shift on a linear spectrogram matrix. The shift is not circular, zeros are
% placed to fill bottom or top of the matrix. 
%
% INPUT
% x: Matrix to be shifted
% s: number of semitones,or quarter tones, depending on b. Positive s shifts down, negative shifts up.
% b: Frequency resolution (12 for semitone, 24 for quartertone, and so on)
%
% OUTPUT
% y: shifted matrix
%
% Author: Alan F. Tygel
% Last Modified: 28/01/2009


y = zeros(size(x,1),size(x,2));
  for k=1:size(x,1)
    lin_shift = round(k*power(2,(shift)/b));
    pulou=false;
    if(lin_shift - round((k-1)*power(2,(shift)/b)) == 2) 
      pulou = true;
    end
    if (lin_shift <=size(x,1)) && (lin_shift > 0)
      for frame = 1 : size(x,2)
        y(lin_shift,frame) = x(k,frame);%y(lin_shift,frame) + x(k,frame);

        if(pulou)&&(lin_shift > 2)                           
		  	  y(lin_shift-1,frame) = (y(lin_shift,frame)+y(lin_shift-2,frame))/2 ;
        end
      end
    end
  end
end
