function A = SF_v_shift(A,s)
% B = SF_v_shift(A,s)
%
% Does the vertical shift on matrix. The shift is not circular, zeros are
% placed to fill bottom or top of the matrix.
%
% INPUT
% A: Matrix to be shifted
% s: number of shifts. Positive s shifts down, negative shifts up.
%
% OUTPUT
% B: shifted matrix
%
% Author: Alan F. Tygel
% Last Modified: 28/01/2009

	if(s~=0)
		A = circshift(A,[s 0]);
		if(s > 0)
		A(1:s,:) = 0;
		elseif(s<0)
		A(end+1+s:end,:) = 0;
		end
	end
end