function [X PH] = STFT(x,L,S,M,FFT_S)
%X = STFT(x,L,S,M,FFT_S)
%
%x: signal to be decomposed
%L: Window length (in samples)
%S: Window advance
%M: number of frames
%FFT_S: size of FFT
%
%X: STFT
 
w = hamming2(L,S);
%w = hamming(L);

PH = zeros(FFT_S,M);
X = zeros(FFT_S,M);
X_aux = zeros(FFT_S,M);
x = x(:);
w = w(:);

for m = 0:M-1
    X_aux(:,m+1) = fft(x(1+m*S:m*S+L).*w,FFT_S);
		X(:,m+1) = X_aux(:,m+1);
		PH(:,m+1) = phase(X_aux(:,m+1));
end
 
 
 
end