function y = iSTFT(X, N, window, hop)
% y = DGistft(X, N, window, hop)
% Calculates the inverse STFT of X where a N-point FFT has been calculated
% with window of N points and hop number of points. 
%
% X = [B; B((end-1):-1:2,:)] where B is from specgram().
%
% David Gunawan 2004

y = zeros(size(X,2)*hop+N-hop,1);
%  scale = mean(window.^2)*N/hop;

H = N/hop;

if(H == 2)
	gain_comp = zeros(N/2,1);
	for k=1:N/2
		for h = 0:H/2
			gain_comp(k) = gain_comp(k) + window(k+h*hop)^2;
		end
	end
else
	gain_comp = mean(window.^2)*N/hop;
end
%  for k=1:N/2
%      gain_comp(k) = 1/(window(k)^2+window(k+N/2)^2);   
%  end


i = 1; % init index of start of frame
for f=1:size(X,2) % for every frame
   % ifft, window, overlap-add
%     y(i:i+N-1) = y(i:i+N-1) + real(ifft(X(:,f))).*window/scale; 
	 aux = real(ifft(X(:,f)));
   y(i:i+N-1) = y(i:i+N-1) + aux(1:N).*window; 
	 y(i:i+N/2-1) = y(i:i+N/2-1) ./gain_comp;
   i = i + hop;
end
