%sim_1_analysis
close all;
clear all;

load sim_NMF2D_LNMF2D_result

sinal = result;


figure(1)
title('SDR')
hold on
figure(2)
title('ODG')
hold on
N_si = length(sinal);


for si = 1:N_si

	N_ai = size(sinal{si}.SDR,1);
	N_oi = size(sinal{si}.SDR,2);
	N_d = size(sinal{si}.SDR,3);
	N_R = size(sinal{si}.SDR,4);

	for ai = 1:N_ai
		for oi = 1:N_oi


			max_SDR = zeros(N_d,1);
			max_PEAQ = zeros(N_d,1);
			for ri = 1:N_R
				score(ri).SDR = zeros(N_d,1); 
				score(ri).PEAQ = zeros(N_d,1); 

				score(ri).SDR = sinal{si}.SDR(ai,oi,:,ri);
				score(ri).PEAQ= sinal{si}.PEAQ(ai,oi,:,ri);

				if(sum(sinal{si}.SDR(ai,oi,:,ri)) >  sum(max_SDR))
					max_SDR = sinal{si}.SDR(ai,oi,:,ri);
					max_PEAQ = sinal{si}.PEAQ(ai,oi,:,ri);
				end

			end
			
			SDR_matrix = zeros(N_R,N_d);
			PEAQ_matrix = zeros(N_R,N_d);

			for	xx=1:N_R, for	yy=1:N_d
				SDR_matrix(xx,yy) = score(xx).SDR(yy); 
				PEAQ_matrix(xx,yy) = score(xx).PEAQ(yy); 
			end,end
		
			for d = 1:N_d
				mean_SDR = mean(SDR_matrix(:,d));
				std_SDR = std(SDR_matrix(:,d));
				mean_PEAQ = mean(PEAQ_matrix(:,d));
				std_PEAQ = std(PEAQ_matrix(:,d));

				figure(1)
				errorbar(si+((ai-1)*.5)+(d-1)*.1,mean_SDR,std_SDR,'o')
				plot(si+((ai-1)*.5)+(d-1)*.1,max_SDR(d),'*')

				figure(2)
				errorbar(si+((ai-1)*.5)+(d-1)*.1,mean_PEAQ,std_PEAQ,'o')
				plot(si+((ai-1)*.5)+(d-1)*.1,max_PEAQ(d),'*')

			end


		end %oi
	end %ai
end %si

hold off


for fig_id = 1:2
	figure(fig_id)
	tick_vector = [];
	label_vector = {};
	for si = 1:N_si
		for d = 0:0%size(sinal{si}.SDR,3)-1
			tick_vector = [tick_vector si+d*.1];
			label_vector = [label_vector ['L (',num2str(sinal{si}.not_conv(1)),')']];
		end
		for d = 0:0%size(sinal{si}.SDR,3)-1
			tick_vector = [tick_vector si+.5+d*.1];
			label_vector = [label_vector ['N (',num2str(sinal{si}.not_conv(2)),')']];
		end
		if (fig_id == 2)
		text(si,-4.2,['Sinal',num2str(si)])
		line([si-.2 si-.2],[-4 -2],'Color',[0 0 0])
		line([si+.3 si+.3],[-4 -2],'Color',[0 1 0])
		else
		text(si,-3,['Sinal',num2str(si)])
		line([si-.2 si-.2],[0 25],'Color',[0 0 0])
		line([si+.3 si+.3],[0 25],'Color',[0 1 0])
		end
	end
	set(gca,'XTick',tick_vector)
	set(gca,'XTickLabel',label_vector)
end

%maior valor
%media 
%variancia
%not_conv

