clear all;
D = 2;
TAU = 2;
PHI = 10;
WS = 512;

filename = 'long_tpt2';
analysis = 'fft';
obj_func = 'kld';

FFT_size = 1024;
max_it = 100;
out_name = 'out_';
delta = 10e-3;

tic

R = 50;
not_conv = 0;
results_SDR = zeros(R,D); % R x QAmethod x D
results_PEAQ= zeros(R,D); 
seeds = zeros(R,1); 


parfor rep = 1:R
	convergiu = 0;
	while (convergiu ~= 1)
		seed = 1e5*sum(clock);
		rand('state',seed);
		seeds(rep) = seed;
	
		disp(['#### test_online ',num2str(rep),'####']);
	
		[error SDR PEAQ SDR_match PEAQ_match] = SoundFact_main(filename,...
		'analysis',analysis,...
		'load_analysis','no',...
		'load_fact','no',...
		'obj_func',obj_func,...
		'processing','wiener',...
		'synthesis','ifft',...
		'd',D,'phi',PHI,'tau',TAU,'max_it',max_it,'delta',delta,...%	'out_name',['greensleaves_fft_kld_',int2str(block_number)],...
		'out_name',[out_name,'_',num2str(rep)],...
		'WS',WS,'FFT_size',FFT_size,...
		'disp_targ','off','disp_plot','off',...
		'bss_eval','yes');%,...

		if((norm(SDR_match-PEAQ_match) == 0) && (sum(SDR_match(:,2)) == sum(1:D)) && (sum(SDR < 0) == 0) && (sum(PEAQ == -5) == 0) ) 
			convergiu = 1;
		else
			disp(['#### nao convergiu ####']);
			not_conv = not_conv +1;
		end

		results_SDR(rep,:) = SDR(:);
		results_PEAQ(rep,:) = PEAQ(:);


	end %while


end %parfor

save results_SF_offline results_SDR results_PEAQ not_conv seeds

%  
%  toc